//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Yellow
#property indicator_color3 Olive
#property indicator_color4 Olive
#property indicator_color5 Orange
#property indicator_color6 Orange
#property indicator_color7 Gray
#property indicator_color8 Gray
#property indicator_width1 2

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    LRlength     = 55;
extern double stdchannel1  =  1;
extern double stdchannel2  =  2;
extern double stdchannel3  =  3;
extern int    RsiLength    = 14;
extern double OmaSpeed     = 1.5;
extern bool   OmaAdaptive  = true;
extern int    Price        = PRICE_CLOSE;
extern string UseSymbol    = "";
extern bool   Interpolate  = true;

//
//
//
//
//

double lrBuffer[];
double upBuffer1[];
double dnBuffer1[];
double upBuffer2[];
double dnBuffer2[];
double upBuffer3[];
double dnBuffer3[];
double prices[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,prices);
   SetIndexBuffer(1,lrBuffer);  SetIndexLabel(0,"mean");
   SetIndexBuffer(2,upBuffer1); SetIndexLabel(1,"1st Std up");
   SetIndexBuffer(3,dnBuffer1); SetIndexLabel(2,"1st Std down");
   SetIndexBuffer(4,upBuffer2); SetIndexLabel(3,"2nd Std up");
   SetIndexBuffer(5,dnBuffer2); SetIndexLabel(4,"2nd Std down");
   SetIndexBuffer(6,upBuffer3); SetIndexLabel(5,"3rd Std up");
   SetIndexBuffer(7,dnBuffer3); SetIndexLabel(6,"3rd Std down");
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() {return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,n,counted_bars=IndicatorCounted();
   string symbol;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { prices[0] = limit+1; return(0); }
           if (iOpen(UseSymbol,0,0)==0)
                  symbol = Symbol();
           else   symbol = UseSymbol;

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         prices[i] = iRsi(iMA(symbol,0,1,0,MODE_SMA,Price,i),RsiLength,OmaSpeed,OmaAdaptive,i);
         double slope;
         double value  = iLRValue(slope,LRlength,i);
         double stddev = 0;

            for(int k=0; k<LRlength; k++)
            {
               double diff = prices[i+k]-(value-k*slope);
                  stddev  += diff*diff;
            }
            stddev = MathSqrt(stddev/(LRlength-1.0));
      
         //
         //
         //
         //
         //
      
         lrBuffer[i]  = value;
         upBuffer1[i] = lrBuffer[i]+(stdchannel1*stddev);
         dnBuffer1[i] = lrBuffer[i]-(stdchannel1*stddev);
         upBuffer2[i] = lrBuffer[i]+(stdchannel2*stddev);
         dnBuffer2[i] = lrBuffer[i]-(stdchannel2*stddev);
         upBuffer3[i] = lrBuffer[i]+(stdchannel3*stddev);
         dnBuffer3[i] = lrBuffer[i]-(stdchannel3*stddev);
      }
      if (!calculateValue) IndicatorShortName("prd "+symbol+" ("+LRlength+")");
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(symbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         prices[i]    = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,0,y);
         lrBuffer[i]  = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,1,y);
         upBuffer1[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,2,y);
         dnBuffer1[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,3,y);
         upBuffer2[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,4,y);
         dnBuffer2[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,5,y);
         upBuffer3[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,6,y);
         dnBuffer3[i] = iCustom(symbol,timeFrame,indicatorFileName,"calculateValue",LRlength,stdchannel1,stdchannel2,stdchannel3,RsiLength,OmaSpeed,OmaAdaptive,Price,7,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               prices[i+k]    = prices[i]    + (prices[i+n]   -prices[i]   )*k/n;
               lrBuffer[i+k]  = lrBuffer[i]  + (lrBuffer[i+n] -lrBuffer[i] )*k/n;
               upBuffer1[i+k] = upBuffer1[i] + (upBuffer1[i+n]-upBuffer1[i])*k/n;
               dnBuffer1[i+k] = dnBuffer1[i] + (dnBuffer1[i+n]-dnBuffer1[i])*k/n;
               upBuffer2[i+k] = upBuffer2[i] + (upBuffer2[i+n]-upBuffer2[i])*k/n;
               dnBuffer2[i+k] = dnBuffer2[i] + (dnBuffer2[i+n]-dnBuffer2[i])*k/n;
               upBuffer3[i+k] = upBuffer3[i] + (upBuffer3[i+n]-upBuffer3[i])*k/n;
               dnBuffer3[i+k] = dnBuffer3[i] + (dnBuffer3[i+n]-dnBuffer3[i])*k/n;
            }               
   }
   IndicatorShortName(timeFrameToString(timeFrame)+" prd oma rsi "+symbol+" ("+LRlength+")");   
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lrperiod=0;
double lrsumX;
double lrsumXSqr;
double lrdivisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrperiod != len)
   {
      lrperiod  = len;
      lrsumX    = lrperiod * (lrperiod-1) / 2.0;
      lrsumXSqr = lrperiod * (lrperiod-1) * (2.0 * lrperiod - 1.0) / 6.0;
      lrdivisor = MathPow(lrsumX,2.0) - lrperiod * lrsumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrperiod; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrdivisor != 0 ) 
         	LinearRegSlope = (lrperiod * SumXY - lrsumX * SumY)/lrdivisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lrsumX) / lrperiod ;
	LinearRegValue = Intercept  + LinearRegSlope * (lrperiod-1);
   return(LinearRegValue);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, double speed, bool adaptive, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*3; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
         double chng   = workRsi[r][_price]-workRsi[r-1][_price];
         double changn = iOma(        chng ,period,speed,adaptive,i,instanceNo*2+0);
         double changa = iOma(MathAbs(chng),period,speed,adaptive,i,instanceNo*2+1);
            if (changn != 0)
                  return(MathMin(MathMax(50.0*(changn/MathMax(changa,0.0000001)+1.0),0),100));
            else  return(50.0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][14];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}